void __fastcall TSetupForm::AnyVportClick(TObject *Sender) {
  if (IsDeriving) return;
  if (lbVports->Items->Count < 1) return;
  IVport = LPDIRECT3DRMVIEWPORT(
             lbVports->Items->Objects[lbVports->ItemIndex]);
  if (!IVport) return;

  if (rbPerspective->Checked)
            IVport->SetProjection(D3DRMPROJECT_PERSPECTIVE);
  else
  if (rbOrthographic->Checked)
           IVport->SetProjection(D3DRMPROJECT_ORTHOGRAPHIC);
  if (Sender == cbScale)
     IVport->SetUniformScaling(cbScale->Checked);

  Refresh();
  GetVportSettings();
  Modified();
}//---------------------------------------------------------
void __fastcall TSetupForm::VPortKeyPress(TObject *Sender,
  char &Key)
{
  if (Key != VK_RETURN) return;
  TEdit *ed = dynamic_cast<TEdit*>(Sender);
  if (!ed || !ed->Modified) return;
  if (lbVports->Items->Count < 1) return;
  IVport = LPDIRECT3DRMVIEWPORT(
             lbVports->Items->Objects[lbVports->ItemIndex]);
  if (!IVport) return;

  try {
     DecimalSeparator = '.';
     D3DVALUE f = ed->Text.ToDouble();
          if (ed == edBack)  IVport->SetBack(f);
     else if (ed == edFront) IVport->SetFront(f);
     else if (ed == edField) IVport->SetField(f);
     Modified();
     ed->Modified = false;
  } catch (Exception &exception) {
     Application->ShowException(&exception);
  }
  Refresh();
  GetVportSettings();
}//---------------------------------------------------------
void __fastcall TSetupForm::AnyPlaneKeyPress(TObject*,
  char &Key)
{
  if (Key != VK_RETURN) return;
  if (lbVports->Items->Count < 1) return;
  IVport = LPDIRECT3DRMVIEWPORT(
            lbVports->Items->Objects[lbVports->ItemIndex]);
  if (!IVport) return;
  D3DVALUE left, right, bottom, top;
  try {
     DecimalSeparator = '.';
     left   = edLeft->Text.ToDouble();
     right  = edRight->Text.ToDouble();
     bottom = edBottom->Text.ToDouble();
     top    = edTop->Text.ToDouble();
     IVport->SetPlane(left, right, bottom, top);
     Modified();
  } catch (Exception &exception) {
     Application->ShowException(&exception);
  }
  Refresh();
  GetVportSettings();
}//---------------------------------------------------------
void __fastcall TSetupForm::lbVportsClick(TObject*){
  GetVportSettings();
}//---------------------------------------------------------
